function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { createContext, useMemo, useState } from 'react';
import { useCart } from "../Cart";
import { calculatePriceDetails } from "./utils";
import { useInit } from "../Init";
import { getDepositProtocolApi } from "./serve";
import { usePisellOS } from "../../../hooks/useEngineContext";

// 定义上下文接口

// 默认步骤状态
var defaultState = {};

// 创建步骤上下文
export var SummaryContext = /*#__PURE__*/createContext(undefined);
export var SummaryProvider = function SummaryProvider(_ref) {
  var children = _ref.children;
  var pisellos = usePisellOS();
  var _useCart = useCart(),
    cartData = _useCart.cartData;
  var _useInit = useInit(),
    initData = _useInit.initData;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isAgreeDepositPolicy = _useState2[0],
    setIsAgreeDepositPolicy = _useState2[1];
  var summaryModule = pisellos.getModule('summary');
  var summaryData = useMemo(function () {
    return calculatePriceDetails((initData === null || initData === void 0 ? void 0 : initData.shop) || {}, cartData.cartItems, summaryModule);
  }, [cartData.cartItems, initData === null || initData === void 0 ? void 0 : initData.shop, summaryModule]);
  var contextValue = {
    // 商品总价
    subtotal: summaryData.subtotal,
    // 总金额
    total: summaryData.total,
    taxTitle: summaryData.taxTitle,
    totalTaxFee: summaryData.totalTaxFee,
    isPriceIncludeTax: summaryData.isPriceIncludeTax,
    taxRate: summaryData.taxRate,
    surcharge: summaryData.surcharge,
    deposit: summaryData.deposit,
    isAgreeDepositPolicy: isAgreeDepositPolicy,
    setIsAgreeDepositPolicy: setIsAgreeDepositPolicy,
    getDepositProtocol: getDepositProtocolApi
  };
  return /*#__PURE__*/React.createElement(SummaryContext.Provider, {
    value: contextValue
  }, children);
};

/**
 * 使用步骤管理的Hook
 * @throws {Error} 如果在StepProvider外部使用会抛出错误
 * @returns {StepContextType} 步骤管理上下文
 */
export var useSummary = function useSummary() {
  var context = React.useContext(SummaryContext);
  if (!context) {
    throw new Error('useSummary must be used within a SummaryProvider');
  }
  return context;
};
export default {
  defaultState: defaultState
};